﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

namespace ShoeSystem
{
    public partial class FormProduct : Form
    {
        public FormProduct()
        {
            InitializeComponent();
        }
        string _idcat;

        private void FormInventory_Load(object sender, EventArgs e)
        {
            ClassConnection.connectionDatabase();
            showcombobox();
            ShowData();
            EnabledFalse();
            buttonDelete.Enabled = false;
            buttonSave.Enabled = false;
            buttonCancel.Enabled = false;
        }

        private void showcombobox()
        {
            try
            {
                comboBox1.Items.Clear();
                ClassConnection.connectionDatabase();
                string Sql = "SELECT Distinct N_category FROM tbcategory ORDER BY N_category";
                ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);
                OleDbDataReader DataReader = ClassConnection.command.ExecuteReader();
                while (DataReader.Read())
                {
                    comboBox1.Items.Add(DataReader["N_category"]);
                }               
                DataReader.Close();
            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.Message.ToString());
                comboBox1.Text = "";
            }
        }   

        private void buttonSearch_Click(object sender, EventArgs e)
        {
            ClassConnection.connectionDatabase();
            string Sql = @"SELECT tbproduct.Id_product,tbproduct.N_product,tbproduct.Id_category, 
                           tbcategory.N_category,tbproduct.pricebuy,tbproduct.pricesale,tbproduct.unit
                            FROM tbproduct,tbcategory WHERE tbproduct.Id_category = tbcategory.Id_category
                            AND tbproduct.Id_product Like @name
                            OR tbproduct.N_product Like @name
                            ORDER BY tbproduct.Id_product";
            ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);
            ClassConnection.command.Parameters.AddWithValue("name", "%" + textBoxSearch.Text + "%");//ค้นหา
            OleDbDataReader DataReader = ClassConnection.command.ExecuteReader();
            ClassConnection.dataTable = new DataTable();
            ClassConnection.dataTable.Load(DataReader);
            dataGridView1.DataSource = ClassConnection.dataTable;
            FormatDataGridView();
        }

        private void buttonSearchAll_Click(object sender, EventArgs e)
        {
            ShowData();
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            ClassConnection.count = 1;
            buttonAdd.Enabled = false;
            buttonEdit.Enabled = false;
            buttonDelete.Enabled = false;
            buttonCancel.Enabled = true;
            buttonSave.Enabled = true;
            EnabledTrue();
            ClearData();
        }

        private void buttonEdit_Click(object sender, EventArgs e)
        {
            ClassConnection.count = 2;
            buttonAdd.Enabled = false;
            buttonEdit.Enabled = false;
            buttonDelete.Enabled = false;
            buttonCancel.Enabled = true;
            buttonSave.Enabled = true;
            textBoxID.Enabled = false;
            EnabledTrue();
        }

        private void buttonSave_Click(object sender, EventArgs e)
        {

            if (textBoxID.Text == "")
            {
                textBoxID.Focus();
                return;
            }
            else if (textBoxName.Text == "")
            {
                textBoxName.Focus();
                return;
            }
            else if (comboBox1.Text == "")
            {
                comboBox1.Select();
                return;
            }
            else if (textBoxPriceBuy.Text == "")
            {
                textBoxPriceBuy.Focus();
                return;
            }
            else if (textBoxPriceSale.Text == "")
            {
                textBoxPriceSale.Focus();
                return;
            }
            else if (textBoxNum.Text == "")
            {
                textBoxNum.Focus();
                return;
            }
            
            if (ClassConnection.count == 1)
            {
                ClassConnection.connectionDatabase();

                string Sql = @"SELECT * FROM tbproduct WHERE N_product = '" + textBoxName.Text + "'";

                ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);

                OleDbDataReader DataReader= ClassConnection.command.ExecuteReader();

                if (DataReader.HasRows)
                {
                    MessageBox.Show("มีข้อมูลซ้ำกรุณาตรวจสอบ", "ตรวจสอบ");
                    return;
                }
                else
                {
                    DataReader.Close();
                    OleDbTransaction tr = ClassConnection.connection.BeginTransaction();//คนแรกให้เข้าคนที่สองเข้ามาซ้ำไม่ได้
                    try
                    {
                        ClassConnection.connectionDatabase();
                        string SqlInsert = @"INSERT INTO tbproduct(Id_product,N_product,Id_category,pricebuy,pricesale,unit)
                                                VALUES(@a,@b,@c,@d,@e,@f)";
                        ClassConnection.command = new OleDbCommand(SqlInsert, ClassConnection.connection);
                        ClassConnection.command.Parameters.AddWithValue("a", textBoxID.Text);
                        ClassConnection.command.Parameters.AddWithValue("b", textBoxName.Text);
                        ClassConnection.command.Parameters.AddWithValue("c", _idcat);
                        ClassConnection.command.Parameters.AddWithValue("d", textBoxPriceBuy.Text);
                        ClassConnection.command.Parameters.AddWithValue("e", textBoxPriceSale.Text);
                        ClassConnection.command.Parameters.AddWithValue("f", textBoxNum.Text);
                        int result = ClassConnection.command.ExecuteNonQuery();
                        if (result == -1)
                        {
                            MessageBox.Show("เกิดข้อผิดพลาด ไม่สามารถเพิ่มข้อมูลได้", "ตรวจสอบ");
                            tr.Rollback();
                        }
                        else
                        {
                            MessageBox.Show("บันทึกข้อมูลแล้ว", "ตรวจสอบ");
                            tr.Commit();
                        }
                    }
                    catch (System.Exception ex)
                    {
                        MessageBox.Show(ex.Message.ToString());
                        tr.Rollback();

                    }//หาสาเหตุ
                    finally
                    {
                        ClassConnection.connectionDatabase();
                        tr.Dispose();
                    }
                }
            }
            else if (ClassConnection.count == 2)
            {
                OleDbTransaction tr = ClassConnection.connection.BeginTransaction();
                try
                {
                    ClassConnection.connectionDatabase();
                    string SqlUpdate = @"UPDATE tbproduct SET N_product =@b,Id_category =@c,pricebuy =@d,pricesale =@e,unit =@f WHERE Id_product = @id";
                    ClassConnection.command = new OleDbCommand(SqlUpdate, ClassConnection.connection);
                    ClassConnection.command.Parameters.AddWithValue("b", textBoxName.Text);
                    ClassConnection.command.Parameters.AddWithValue("c", _idcat);
                    ClassConnection.command.Parameters.AddWithValue("d", textBoxPriceBuy.Text);
                    ClassConnection.command.Parameters.AddWithValue("e", textBoxPriceSale.Text);
                    ClassConnection.command.Parameters.AddWithValue("f", textBoxNum.Text);
                    ClassConnection.command.Parameters.AddWithValue("id", textBoxID.Text);
                    int result = ClassConnection.command.ExecuteNonQuery();
                    if (result == -1)
                    {
                        MessageBox.Show("เกิดข้อผิดพลาด ไม่สามารถแก้ไขข้อมูลได้", "ตรวจสอบ");
                        tr.Rollback();
                    }
                    else
                    {
                        MessageBox.Show("แก้ไขข้อมูลแล้ว", "ตรวจสอบ");
                        tr.Commit();
                    }
                }
                catch (System.Exception ex)
                {
                    MessageBox.Show(ex.Message.ToString());
                    tr.Rollback();
                }
                finally
                {
                    ClassConnection.connectionDatabase();
                    tr.Dispose();
                }

            }
            buttonSave.Enabled = false;
            buttonCancel.Enabled = false;
            buttonAdd.Enabled = true;
            buttonEdit.Enabled = true;
            buttonDelete.Enabled = true;
            ClearData();
            ShowData();
            ClassConnection.count = 0;
            EnabledFalse();
        }

        private void buttonDelete_Click(object sender, EventArgs e)
        {
            DialogResult result = MessageBox.Show("ต้องการลบข้อมูลจริงหรือไม่", "ยืนยันการลบ");
            if (result == DialogResult.Cancel)
            {
                return;
            }
            OleDbTransaction tr = ClassConnection.connection.BeginTransaction();
            try
            {
                ClassConnection.connectionDatabase();
                string Sql = @"DELETE FROM tbproduct WHERE Id_product = @id";
                ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);
                ClassConnection.command.Parameters.AddWithValue("id", textBoxID.Text);
                int r = (int)ClassConnection.command.ExecuteNonQuery();
                if (r == -1)
                {
                    MessageBox.Show("เกิดข้อผิดพลาด ไม่สามารถลบข้อมูลได้", "ตรวจสอบ");
                    tr.Rollback();
                }
                else
                {
                    MessageBox.Show("ลบข้อมูลแล้ว", "ตรวจสอบ");
                    tr.Commit();
                    ClearData();
                    ShowData();
                }
            }
            catch
            {
                tr.Rollback();
            }
            finally
            {
                ClassConnection.connectionDatabase();
                tr.Dispose();
            }
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            ClassConnection.connectionDatabase();
            ClearData();
            ShowData();
            EnabledFalse();
            buttonAdd.Enabled = true;
            buttonEdit.Enabled = true;
            buttonDelete.Enabled = false;
            buttonSave.Enabled = false;
            buttonCancel.Enabled = false;
        }

        private void dataGridView1_CellMouseUp(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                if (e.RowIndex == -1)
                {
                    return;
                }

                textBoxID.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[0].Value.ToString());
                textBoxName.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[1].Value.ToString());
                comboBox1.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[3].Value.ToString());
                textBoxPriceBuy.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[4].Value.ToString());
                textBoxPriceSale.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[5].Value.ToString());
                textBoxNum.Text = Convert.ToString(dataGridView1.Rows[e.RowIndex].Cells[6].Value.ToString());

                buttonEdit.Enabled = true;
                buttonDelete.Enabled = true;
            }
            catch
            {
                buttonEdit.Enabled = false;
                buttonDelete.Enabled = false;
                ClearData();
            }
        }


        //private void MaxID()
        //{
        //    int maxId = 0;
        //    ClassConnection.connectionDatabase();
        //    ClassConnection.Sql = @"SELECT MAX(Pro_ID) FROM Product";
        //    ClassConnection.Command = new SqlCommand(ClassConnection.Sql, ClassConnection.Connection);
        //    //ClassConnection.DataReader = ClassConnection.Command.ExecuteReader();
        //    try
        //    {
        //        maxId = Convert.ToInt32(ClassConnection.Command.ExecuteScalar());
        //    }
        //    catch (Exception ex)
        //    {
        //        maxId = 0;
        //    }
        //    textBoxID.Text = (maxId + 1).ToString();
        //}

        private void EnabledTrue()
        {
            textBoxID.Enabled = true;
            textBoxName.Enabled = true;
            comboBox1.Enabled = true;
            textBoxPriceSale.Enabled = true;
            textBoxPriceBuy.Enabled = true;
            textBoxNum.Enabled = true;
        }
        private void EnabledFalse()
        {
            textBoxID.Enabled = false;
            textBoxName.Enabled = false;
            comboBox1.Enabled = false;
            textBoxPriceSale.Enabled = false;
            textBoxPriceBuy.Enabled = false;
            textBoxNum.Enabled = false;
        }

        private void ClearData()
        {
            textBoxID.Text = "";
            textBoxName.Text = "";
            comboBox1.Text = "";
            textBoxPriceSale.Text = "";
            textBoxPriceBuy.Text = "";
            textBoxNum.Text = "";
            textBoxID.Focus();
        }

        private void ShowData()
        {
            ClassConnection.connectionDatabase();
            string Sql = @"SELECT tbproduct.Id_product,tbproduct.N_product,tbproduct.Id_category, 
                           tbcategory.N_category,tbproduct.pricebuy,tbproduct.pricesale,tbproduct.unit
                            FROM tbproduct,tbcategory WHERE tbproduct.Id_category = tbcategory.Id_category
                            ORDER BY tbproduct.Id_product";
            ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);
            OleDbDataReader DataReader = ClassConnection.command.ExecuteReader();
            if (DataReader.HasRows)
            {
                ClassConnection.dataTable = new DataTable();
                ClassConnection.dataTable.Load(DataReader);
                dataGridView1.DataSource = ClassConnection.dataTable;
                FormatDataGridView();
                DataReader.Close();
            }
            else
            {
                ClassConnection.dataTable = new DataTable();
                ClassConnection.dataTable.Load(DataReader);
                dataGridView1.DataSource = ClassConnection.dataTable;
                FormatDataGridView();
                DataReader.Close();
            }
        }

        private void FormatDataGridView()
        {
            dataGridView1.Columns[0].HeaderText = "รหัสสินค้า";
            dataGridView1.Columns[1].HeaderText = "ชื่อสินค้า";
            dataGridView1.Columns[2].HeaderText = "รหัสประเภทสินค้า";
            dataGridView1.Columns[3].HeaderText = "ชื่อประเภทสินค้า";
            dataGridView1.Columns[4].HeaderText = "ราคาซื้อ";
            dataGridView1.Columns[5].HeaderText = "ราคาขาย";
            dataGridView1.Columns[6].HeaderText = "จำนวนที่มี";

            dataGridView1.Columns[0].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[2].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[3].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[4].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[5].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[6].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

            dataGridView1.Columns[2].Visible = false;
        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            try
            {
                //comboBox1.Items.Clear();
                ClassConnection.connectionDatabase();
                string Sql = "SELECT Id_category FROM tbcategory WHERE N_category =@cat";
                ClassConnection.command = new OleDbCommand(Sql, ClassConnection.connection);
                ClassConnection.command.Parameters.AddWithValue("cat",comboBox1.Text);
                OleDbDataReader DataReader = ClassConnection.command.ExecuteReader();
                DataReader.Read();
                _idcat = DataReader["Id_category"].ToString();
                DataReader.Close();
            }
            catch (Exception ex)
            {
                //MessageBox.Show(ex.Message.ToString());
                comboBox1.Text = "";
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void textBoxNum_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
