﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
using System.Data.OleDb;

namespace ShoeSystem
{
    public partial class FormReportSale : Form
    {
        private project_shirtDataSet dsEx = new project_shirtDataSet();

        private string StrConn = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=database.accdb;Persist Security Info=True;";
        private OleDbConnection Connection;
        private DataSet DataSt;
        private OleDbCommand command;
        private OleDbDataAdapter DataAdapter;
        private DataTable dataTable;
        private string Sql = "";

        public FormReportSale()
        {
            InitializeComponent();
        }


        private void FormatDataGridView()
        {
            dataGridView1.Columns[0].HeaderText = "รหัสสินค้า";
            dataGridView1.Columns[1].HeaderText = "ชื่อสินค้า";
            dataGridView1.Columns[2].HeaderText = "ราคาขาย";
            dataGridView1.Columns[3].HeaderText = "จำนวนที่ขาย";
            dataGridView1.Columns[4].HeaderText = "ราคารวม";
            dataGridView1.Columns[5].HeaderText = "วันเดือนปีที่ขาย";

            dataGridView1.Columns[0].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[2].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[3].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[4].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dataGridView1.Columns[5].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
        }

        private void ConnectionDatabase()
        {  
	        Connection = new OleDbConnection();
	        if (Connection.State == ConnectionState.Open) {
		        Connection.Close();
	        } else {
		        Connection.ConnectionString = StrConn;
		        Connection.Open();
	        }
        }

        private void SearchData()
        {
            Sql = "SELECT tbsaleitem.Id_product,tbproduct.N_product,tbsaleitem.saleitempricesale,";
            Sql += "SUM(tbsaleitem.saleitemqty),SUM(tbsaleitem.saleitemtotal),tbsale.saledate";
            Sql += " FROM tbsale,tbproduct,tbsaleitem";
            Sql += " WHERE tbsaleitem.Id_product = tbproduct.Id_product";
            Sql += " AND tbsale.saleid = tbsaleitem.saleid";
            //Sql += " AND tbsale.saledate BETWEEN #" + "5/4/2015" + "# And #" + "5/4/2015" + "#";
            Sql += " AND tbsale.saledate BETWEEN #" + dateTimePicker1.Value.AddYears(-543).ToString("M/d/yyyy") + "# And #" + dateTimePicker2.Value.AddYears(-543).ToString("M/d/yyyy") + "#";
            Sql += " GROUP BY tbsaleitem.Id_product,tbproduct.N_product,tbsaleitem.saleitempricesale,tbsale.saledate";
            Sql += " ORDER BY tbsale.saledate";

            command = new OleDbCommand(Sql, Connection);


            OleDbDataReader DataReader = command.ExecuteReader();
            if (DataReader.HasRows)
            {
                dataTable = new DataTable();
                dataTable.Load(DataReader);
                dataGridView1.DataSource = dataTable;
                FormatDataGridView();
                DataReader.Close();
            }
            else
            {
                dataTable = new DataTable();
                dataTable.Load(DataReader);
                dataGridView1.DataSource = dataTable;
                FormatDataGridView();
                DataReader.Close();
            }
        }


        private void DataReport()
        {
            
            //MessageBox.Show(dateTimePicker1.Value.ToString());
            //MessageBox.Show(dateTimePicker1.Text.ToString());
            try
            {
                if (dsEx.DataTableBuy.Rows.Count > 0)
                {
                    dsEx.DataTableBuy.Rows.Clear();
                }
                for (int i = 0; i <= dataGridView1.Rows.Count - 1; i++)
                {
                    DataGridViewRow dr = null;
                    dr = dataGridView1.Rows[i];
                    dsEx.DataTableBuy.Rows.Add(dr.Cells[0].Value, dr.Cells[1].Value, dr.Cells[2].Value, dr.Cells[3].Value, dr.Cells[4].Value, String.Format("{0:d MMMM yyyy}", dr.Cells[5].Value));
                }
                CrystalReportBuy crv = new CrystalReportBuy();
                crv.SetDataSource(dsEx);
                crv.SetParameterValue("date1", String.Format("{0:d MMMM yyyy}", dateTimePicker1.Value));
                crv.SetParameterValue("date2", String.Format("{0:d MMMM yyyy}", dateTimePicker2.Value));
                FormReport form = new FormReport();
                form.crystalReportViewer1.ReportSource = crv;
                form.crystalReportViewer1.Refresh();
                form.ShowDialog();
            }
            catch
            {
            }
        }

        private void SearchDataAll()
        {

            Sql = "SELECT tbsaleitem.Id_product,tbproduct.N_product,tbsaleitem.saleitempricesale,";
            Sql += "SUM(tbsaleitem.saleitemqty),SUM(tbsaleitem.saleitemtotal),tbsale.saledate";
            Sql += " FROM tbsale,tbproduct,tbsaleitem";
            Sql += " WHERE tbsaleitem.Id_product = tbproduct.Id_product";
            Sql += " AND tbsale.saleid = tbsaleitem.saleid";
            Sql += " GROUP BY tbsaleitem.Id_product,tbproduct.N_product,tbsaleitem.saleitempricesale,tbsale.saledate";
            //Sql += " AND Format(tbsale.saledate , '" + "dd/mm/yyyy" + "') BETWEEN #" + dateTimePicker1.Text + "# And #" + dateTimePicker2.Text + "#";
            Sql += " ORDER BY tbsale.saledate";

            command = new OleDbCommand(Sql, Connection);

            OleDbDataReader DataReader = command.ExecuteReader();
            if (DataReader.HasRows)
            {
                dataTable = new DataTable();
                dataTable.Load(DataReader);
                dataGridView1.DataSource = dataTable;
                FormatDataGridView();
                DataReader.Close();
            }
            else
            {
                dataTable = new DataTable();
                dataTable.Load(DataReader);
                dataGridView1.DataSource = dataTable;
                FormatDataGridView();
                DataReader.Close();
            }


        }


        private void ReportOrderNew_Load(object sender, EventArgs e)
        {
            //System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");
            ConnectionDatabase();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            SearchData();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            SearchDataAll();
        }

        private void buttonReport_Click(object sender, EventArgs e)
        {
            DataReport();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            dataGridView1.DataSource = null;
        }

    }
}
